<html>
<head>
<title>OGRE: OgreString.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreString.h</h1><a href="OgreString_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef _String_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define _String_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// If we're using the GCC 3.1 C++ Std lib</span>
<a name="l00035"></a>00035 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_GNUC &amp;&amp; OGRE_COMP_VER &gt;= 310 &amp;&amp; !defined(STLPORT)</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;ext/hash_map&gt;</span>
<a name="l00038"></a>00038 <span class="keyword">namespace </span>__gnu_cxx
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040     <span class="keyword">template</span> &lt;&gt; <span class="keyword">struct </span>hash&lt; Ogre::<a class="code" href="namespaceOgre.html#6190e7c0a19190277aeadf25f536ac8c">_StringBase</a> &gt;
<a name="l00041"></a>00041     {
<a name="l00042"></a>00042         <span class="keywordtype">size_t</span> operator()( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#6190e7c0a19190277aeadf25f536ac8c">Ogre::_StringBase</a> _stringBase )<span class="keyword"> const</span>
<a name="l00043"></a>00043 <span class="keyword">        </span>{
<a name="l00044"></a>00044             <span class="comment">/* This is the PRO-STL way, but it seems to cause problems with VC7.1</span>
<a name="l00045"></a>00045 <span class="comment">               and in some other cases (although I can't recreate it)</span>
<a name="l00046"></a>00046 <span class="comment">            hash&lt;const char*&gt; H;</span>
<a name="l00047"></a>00047 <span class="comment">            return H(_stringBase.c_str());</span>
<a name="l00048"></a>00048 <span class="comment">            */</span>
<a name="l00050"></a>00050             <span class="keyword">register</span> <span class="keywordtype">size_t</span> ret = 0;
<a name="l00051"></a>00051             <span class="keywordflow">for</span>( Ogre::_StringBase::const_iterator it = _stringBase.begin(); it != _stringBase.end(); ++it )
<a name="l00052"></a>00052                 ret = 5 * ret + *it;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054             <span class="keywordflow">return</span> ret;
<a name="l00055"></a>00055         }
<a name="l00056"></a>00056     };
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="preprocessor">#endif</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>
<a name="l00061"></a>00061 <span class="keyword">namespace </span>Ogre {
<a name="l00062"></a>00062 
<a name="l00064"></a><a class="code" href="classOgre_1_1StringUtil.html">00064</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StringUtil.html" title="Utility class for manipulating Strings.">StringUtil</a>
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066     <span class="keyword">public</span>:
<a name="l00067"></a><a class="code" href="classOgre_1_1StringUtil.html#ad3e31a0bb6592035b9e646a2bd9f0dc">00067</a>         <span class="keyword">typedef</span> std::ostringstream StrStreamType;
<a name="l00068"></a>00068 
<a name="l00076"></a>00076         <span class="keyword">static</span> <span class="keywordtype">void</span> trim( <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keywordtype">bool</span> left = <span class="keyword">true</span>, <span class="keywordtype">bool</span> right = <span class="keyword">true</span> );
<a name="l00077"></a>00077 
<a name="l00086"></a>00086         <span class="keyword">static</span> std::vector&lt; String &gt; split( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; delims = <span class="stringliteral">"\t\n "</span>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxSplits = 0);
<a name="l00087"></a>00087 
<a name="l00090"></a>00090         <span class="keyword">static</span> <span class="keywordtype">void</span> toLowerCase( <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str );
<a name="l00091"></a>00091 
<a name="l00094"></a>00094         <span class="keyword">static</span> <span class="keywordtype">void</span> toUpperCase( <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str );
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00102"></a>00102         <span class="keyword">static</span> <span class="keywordtype">bool</span> startsWith(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> lowerCase = <span class="keyword">true</span>);
<a name="l00103"></a>00103 
<a name="l00109"></a>00109         <span class="keyword">static</span> <span class="keywordtype">bool</span> endsWith(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> lowerCase = <span class="keyword">true</span>);
<a name="l00110"></a>00110 
<a name="l00113"></a>00113         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> standardisePath( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;init);
<a name="l00114"></a>00114 
<a name="l00120"></a>00120         <span class="keyword">static</span> <span class="keywordtype">void</span> splitFilename(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; qualifiedName,
<a name="l00121"></a>00121             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; outBasename, <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; outPath);
<a name="l00122"></a>00122 
<a name="l00128"></a>00128         <span class="keyword">static</span> <span class="keywordtype">void</span> splitFullFilename(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; qualifiedName, 
<a name="l00129"></a>00129             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; outBasename, <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; outExtention, 
<a name="l00130"></a>00130             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; outPath);
<a name="l00131"></a>00131 
<a name="l00135"></a>00135         <span class="keyword">static</span> <span class="keywordtype">void</span> splitBaseFilename(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; fullName, 
<a name="l00136"></a>00136             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; outBasename, <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; outExtention);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00144"></a>00144         <span class="keyword">static</span> <span class="keywordtype">bool</span> match(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> caseSensitive = <span class="keyword">true</span>);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00151"></a><a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da">00151</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> BLANK;
<a name="l00152"></a>00152     };
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_GNUC &amp;&amp; OGRE_COMP_VER &gt;= 310 &amp;&amp; !defined(STLPORT)</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>    typedef ::__gnu_cxx::hash&lt; _StringBase &gt; <a class="code" href="namespaceOgre.html#4adaf30a5217767650a9e0b0b4de540c">_StringHash</a>;
<a name="l00157"></a>00157 <span class="preprocessor">#elif !defined( _STLP_HASH_FUN_H )</span>
<a name="l00158"></a><a class="code" href="namespaceOgre.html#4adaf30a5217767650a9e0b0b4de540c">00158</a> <span class="preprocessor"></span>    <span class="keyword">typedef</span> stdext::hash_compare&lt; _StringBase, std::less&lt; _StringBase &gt; &gt; <a class="code" href="namespaceOgre.html#4adaf30a5217767650a9e0b0b4de540c">_StringHash</a>;
<a name="l00159"></a>00159 <span class="preprocessor">#else</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span>    <span class="keyword">typedef</span> std::hash&lt; _StringBase &gt; <a class="code" href="namespaceOgre.html#4adaf30a5217767650a9e0b0b4de540c">_StringHash</a>;
<a name="l00161"></a>00161 <span class="preprocessor">#endif</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span>
<a name="l00163"></a>00163 } <span class="comment">// namespace Ogre</span>
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="preprocessor">#endif // _String_H__</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
